%define name FJSVdr-util-RHEL6
%define version 1.1.0
%define release 1

%define dp_home_dir    /opt/FJSVdr-util
%define dp_etc_dir     /opt/FJSVdr-util/etc
%define dp_lib_dir     /opt/FJSVdr-util/lib
%define dp_libexec_dir /opt/FJSVdr-util/libexec
%define dp_core_dir    /opt/FJSVdr-util/libexec/dp-core
%define dp_sbin_dir    /opt/FJSVdr-util/sbin
%define dp_tools_dir   /opt/FJSVdr-util/tools
%define dp_log_dir     /opt/FJSVdr-util/var/log
%define dp_com_dir     /opt/FJSVdr-util/user_command
%define python_lib     /usr/lib/python2.6/site-packages
%define udev_rule_dir  /etc/udev/rules.d
%define dp_boot_opt    "pci=hpiosize=0 pci=hpmemsize=8m pciehp.pciehp_force=1 acpi_memhotplug.mem_hotadd_auto=N notsc"

Name:        %{name}
Version:     %{version}
Release:     %{release}
Summary:     Dynamic Reconfiguration utility for PRIMEQUEST 2000 series

Group:       System Environment/Base
License:     GPLv2
Vendor:      FUJITSU LIMITED
Packager:    FUJITSU LIMITED
URL:         http://www.fujitsu.com/
Source0:     %{name}-%{version}.tar.bz2
Source1:     90-FJSVdr-util-detect-passthrough-dev
Source2:     10-FJSVdr-util-kdump-restart
Source3:     89-FJSVdr-util-irqbalance-restart
Source4:     11-FJSVdr-util-cpuspeed-restart
BuildRoot:   %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildArch:   noarch
Requires:    python >= 2.6
Requires:    grubby
Requires:    ipmitool
Requires:    kexec-tools

%description
Provides a set of Dynamic Reconfiguration command user interface
and related service scripts. And also provides some Dynamic
Reconfiguration collaborate scripts.

%prep
%setup -q

%build

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{dp_etc_dir}
mkdir -p $RPM_BUILD_ROOT%{dp_lib_dir}
mkdir -p $RPM_BUILD_ROOT%{dp_libexec_dir}
mkdir -p $RPM_BUILD_ROOT%{dp_core_dir}
mkdir -p $RPM_BUILD_ROOT%{dp_sbin_dir}
mkdir -p $RPM_BUILD_ROOT%{dp_tools_dir}
mkdir -p $RPM_BUILD_ROOT%{dp_log_dir}
mkdir -p $RPM_BUILD_ROOT%{dp_com_dir}
mkdir -p $RPM_BUILD_ROOT%{_initddir}
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/{rc{0,1,3,5,6}.d}

# etc
install -m 0644 -o root -g root \
	etc/dr_report.conf $RPM_BUILD_ROOT%{dp_etc_dir}
# lib
install -m 0644 -o root -g root \
	lib/dp.py $RPM_BUILD_ROOT%{dp_lib_dir}
install -m 0644 -o root -g root \
	lib/ipmi.py $RPM_BUILD_ROOT%{dp_lib_dir}
install -m 0644 -o root -g root \
	lib/dp_compat.py $RPM_BUILD_ROOT%{dp_lib_dir}
# libexec
install -m 0755 -o root -g root \
	libexec/udev_dp_bridge.py $RPM_BUILD_ROOT%{dp_libexec_dir}
install -m 0755 -o root -g root \
	libexec/dp_send_ready.py $RPM_BUILD_ROOT%{dp_libexec_dir}
install -m 0755 -o root -g root \
	libexec/dp_send_not_ready.py $RPM_BUILD_ROOT%{dp_libexec_dir}
# dp-core
install -m 0755 -o root -g root \
	libexec/dp-core/dp_add.py $RPM_BUILD_ROOT%{dp_core_dir}
install -m 0755 -o root -g root \
	libexec/dp-core/dp_rm.py $RPM_BUILD_ROOT%{dp_core_dir}
install -m 0755 -o root -g root \
	libexec/dp-core/dp_show.py $RPM_BUILD_ROOT%{dp_core_dir}
install -m 0755 -o root -g root \
	libexec/dp-core/dp_stat.py $RPM_BUILD_ROOT%{dp_core_dir}
install -m 0755 -o root -g root \
	libexec/dp-core/dp_report.py $RPM_BUILD_ROOT%{dp_core_dir}
# sbin
install -m 0755 -o root -g root \
	sbin/dp $RPM_BUILD_ROOT%{dp_sbin_dir}/dr
# tools
install -m 0644 -o root -g root \
	tools/RHEL6/FJSVdr-util.rules $RPM_BUILD_ROOT%{dp_tools_dir}
install -m 0755 -o root -g root \
	tools/udev_dp_bridge.sh $RPM_BUILD_ROOT%{dp_tools_dir}
# initscript
install -m 0755 -o root -g root \
	tools/RHEL6/FJSVdr-util.init $RPM_BUILD_ROOT%{_initddir}/FJSVdr-util-RHEL6
# logrotate file
install -m 0644 -o root -g root tools/common/FJSVdr-util.logrotate \
	$RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d/FJSVdr-util
# user_command
install -m 0755 -o root -g root %{SOURCE1} $RPM_BUILD_ROOT%{dp_com_dir}
install -m 0755 -o root -g root %{SOURCE2} $RPM_BUILD_ROOT%{dp_com_dir}
install -m 0755 -o root -g root %{SOURCE3} $RPM_BUILD_ROOT%{dp_com_dir}
install -m 0755 -o root -g root %{SOURCE4} $RPM_BUILD_ROOT%{dp_com_dir}

%post
if [ "$1" = 1 ]; then  # when rpm -i
	## install service
	/sbin/chkconfig --add FJSVdr-util-RHEL6
	/sbin/chkconfig FJSVdr-util-RHEL6 on
	## for kdump
	/bin/sed -i -e "s/^/#/g" /etc/udev/rules.d/98-kexec.rules
fi
## create symlinks
ln -sf $RPM_BUILD_ROOT%{dp_sbin_dir}/dr /sbin/dr
ln -sf $RPM_BUILD_ROOT%{dp_lib_dir}/dp.py %{python_lib}/dp.py
ln -sf $RPM_BUILD_ROOT%{dp_lib_dir}/ipmi.py %{python_lib}/ipmi.py
ln -sf $RPM_BUILD_ROOT%{dp_lib_dir}/dp_compat.py %{python_lib}/dp_compat.py
ln -sf $RPM_BUILD_ROOT%{dp_tools_dir}/FJSVdr-util.rules \
	$RPM_BUILD_ROOT%{udev_rule_dir}/96-FJSVdr-util.rules
## add boot option for DR
KERNEL_LIST=$(/bin/ls /boot/vmlinuz-*)
for KERNEL in ${KERNEL_LIST[@]}
do
	/sbin/grubby --update-kernel $KERNEL --args=%{dp_boot_opt}
done
## overwrite 40-redhat.rules
/bin/cp -f /lib/udev/rules.d/40-redhat.rules /etc/udev/rules.d/
/bin/ed /etc/udev/rules.d/40-redhat.rules > /dev/null 2>&1 <<EOF
g/ACTION=="add", KERNEL=="cpu/d
w
EOF

%preun
if [ "$1" = 0 ]; then  # when rpm -e
	## uninstall service
	/sbin/service FJSVdr-util-RHEL6 stop > /dev/null 2>&1
	/sbin/chkconfig --del FJSVdr-util-RHEL6
	
	## cleanup symlinks
	if [ -f $RPM_BUILD_ROOT%{dp_sbin_dir}/dp_main.py ];
	then
		rm -f $RPM_BUILD_ROOT%{dp_sbin_dir}/dp_main.py
	fi	
	if [ -f /sbin/dr ];
	then
		rm -f /sbin/dr
	fi
	if [ -f $RPM_BUILD_ROOT%{python_lib}/dp.py ];
	then
		rm -f $RPM_BUILD_ROOT%{python_lib}/dp.py
	fi
	if [ -f $RPM_BUILD_ROOT%{python_lib}/ipmi.py ];
	then
		rm -f $RPM_BUILD_ROOT%{python_lib}/ipmi.py
	fi
	if [ -f $RPM_BUILD_ROOT%{python_lib}/dp_compat.py ];
	then
		rm -f $RPM_BUILD_ROOT%{python_lib}/dp_compat.py
	fi	
	if [ -f $RPM_BUILD_ROOT%{udev_rule_dir}/96-FJSVdr-util.rules ];
	then
		rm -f $RPM_BUILD_ROOT%{udev_rule_dir}/96-FJSVdr-util.rules
	fi
	## delete customized 40-readhat.rules
	if [ -f /etc/udev/rules.d/40-redhat.rules ];
	then
		rm -rf /etc/udev/rules.d/40-redhat.rules
	fi	
fi

%postun
if [ "$1" = 0 ]; then	# when rpm -e
    ## remove boot option for DR
	KERNEL_LIST=$(/bin/ls /boot/vmlinuz-*)
	for KERNEL in ${KERNEL_LIST[@]}
	do
		/sbin/grubby --update-kernel $KERNEL --remove-args=%{dp_boot_opt}
	done
	## for kdump
	/bin/sed -i -e "s/^#//g" /etc/udev/rules.d/98-kexec.rules
fi

%clean
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%{dp_home_dir}
%config(noreplace) %{dp_etc_dir}/dr_report.conf
%{_initddir}/FJSVdr-util-RHEL6
%config(noreplace) %{_sysconfdir}/logrotate.d/FJSVdr-util

%changelog
* Wed Aug 20 2014 FUJITSU LIMITED
- Do not send IPMI error code in case of minor errors in IOU hotplug
- Change the value of pci=hpmemsize boot option (Specfile)
- (BS01585)

* Thu Mar 06 2014 FUJITSU LIMITED
- first build
- (BS01572)


